// Copyright (C)2008 Laurence Tratt http://tratt.net/laurie/
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
// IN THE SOFTWARE.


typedef enum {BATCH_MODE, DAEMON_MODE} Mode;

typedef struct {
    char *spool_dir;
    Mode mode;
    time_t notify_failure_interval; // How many seconds should mail not be sent
                                    // before notify_cmd should be executed. If
                                    // set to 0, means that notify_cmd sholud
                                    // never be executed.
    const char *notify_failure_cmd; // The command to be executed by system(3)
                                    // when notify_failure_interval seconds have
                                    // elapsed since a successful send cycle.
    const char *notify_success_cmd; // The command to be executed by system(3)
                                    // when message(s) are successfully sent
} Conf;
